local Gem = GemSocketsAddon;
local sockets = Gem.sockets;
local hovered = false;
local hover = false;
local good = false;
local selectedSocketSlot = 1;

local infos = 
    {
        [1] = { ["name"] = "CharacterHeadSlot"},
        [2] = { ["name"] = "CharacterNeckSlot"},
        [3] = { ["name"] = "CharacterShoulderSlot"},
        [4] = { ["name"] = "CharacterShirtSlot"},
        [5] = { ["name"] = "CharacterChestSlot"},
        [6] = { ["name"] = "CharacterWaistSlot"},
        [7] = { ["name"] = "CharacterLegsSlot"},
        [8] = { ["name"] = "CharacterFeetSlot"},
        [9] = { ["name"] = "CharacterWristSlot"},
        [10] = { ["name"] = "CharacterHandsSlot"},
        [11] = { ["name"] = "CharacterFinger0Slot"},
        [12] = { ["name"] = "CharacterFinger1Slot"},
        [13] = { ["name"] = "CharacterTrinket0Slot"},
        [14] = { ["name"] = "CharacterTrinket1Slot"},
        [15] = { ["name"] = "CharacterBackSlot"},
        [16] = { ["name"] = "CharacterMainHandSlot"},
        [17] = { ["name"] = "CharacterSecondaryHandSlot"},
        [19] = { ["name"] = "CharacterTabardSlot"}
    };

local gemID = {};
local origsEnter = {};
local origsLeave = {};
local ft = {};
local clicked = false;

function sockets.showGameTooltip(self, motion)
    hovered = self.name;
    if self.link then
        GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
        GameTooltip:SetHyperlink(self.link);
        GameTooltip:Show();
    end
end

function sockets.hideGameTooltip(self, motion)
    GameTooltip:Hide();
end

function sockets.setTooltip()
    for id, item in pairs(infos) do
        local continue = true;
        frame = _G[item.name];
        itemLink = GetInventoryItemLink("player", id);

        if itemLink == nil then
            continue = true;
        end
        if continue then
            good = true;
            frame.id = id;
            frame.name = item.name;
            origsEnter[item.name] = frame:GetScript("OnEnter");
            origsLeave[item.name] = frame:GetScript("OnLeave");
            frame:SetScript("OnEnter", sockets.showGemsEnter);
            frame:SetScript("OnUpdate", sockets.showGemsUpdate);
            frame:SetScript("OnLeave", sockets.showGemsLeave);   
        end
    end
end

function sockets.showGemsEnter(self, motion)
    hovered = self.name;
    hover = true;
    clicked = false;
    pcall(hideFrame);
    if origsEnter[self.name] then return origsEnter[self.name](self, motion) end
end

function sockets.showGemsLeave(self, motion)
    hovered = false;
    if origsLeave[self.name] then return origsLeave[self.name](self, motion) end
end


function sockets.showGemsUpdate(self, motion)
    self.link = GetInventoryItemLink("player", self.id);
    if ( IsShiftKeyDown() and hovered == self.name and self.link ~= nil and clicked == false) then 
        if hover then
            GameTooltip:Hide();
            hover = false;
        end
        loadGems();

        i = 0;
        local canGem = false;
        local slotID = self.id;
        local itemLink = GetInventoryItemLink("player", slotID);
        
        local EMPTY_SOCKET_PRISMATIC = 1

        local stats = GetItemStats(itemLink);
        if stats ~= nil then
            for key, val in pairs(stats) do
            if (string.find(key, "EMPTY_SOCKET_")) then
                    EMPTY_SOCKET_PRISMATIC = val
                    canGem = true;
                end
            end
        end

        if canGem then      
            local lastFrame = self;
            local i = 0;
            local m = 0;
            local list = {};
            local mlimit = 5
            list = gemID;
            index = 0;
            if ft["dropDownSocketSlot"] == nil and EMPTY_SOCKET_PRISMATIC > 1 then
                ft["dropDownSocketSlot"] = CreateUIDropDownMenuTemplate(lastFrame, EMPTY_SOCKET_PRISMATIC)
                ft["dropDownSocketSlot"]:SetPoint("BOTTOMLEFT", lastFrame, "BOTTOMLEFT", lastFrame:GetWidth(), 35 );
                selectedSocketSlot = 1
                ft["dropDownSocketSlot"]:Show()
            elseif EMPTY_SOCKET_PRISMATIC == 1 then
                selectedSocketSlot = 1
            end
            for id, item in pairs(list) do

                local tmpPos = 0;
                gamname = item.name;
                local gem = UseContainerItemByName(gamname, 0);
                
                if gem ~= false then
                    i = i + 1;
                    if i == mlimit then
                        m = m + 1;
                        tmpPos = 0 - (lastFrame:GetHeight() * m) - 5;
                        lastFrame = self;
                        i = 1;
                    end

                    if ft[index] == nil then
                        ft[index] = CreateFrame("Button", "OVERLAY", self, nil);
                    end

                    ft[index]:SetPoint("BOTTOMLEFT", lastFrame, "BOTTOMLEFT", lastFrame:GetWidth() + 1, tmpPos);
                    lastFrame = ft[index];

                    local t = ft[index]:CreateTexture(nil, "ARTWORK");
                        t:SetTexture(item.icon);
                        t:SetAllPoints(ft[index]);                        
                    ft[index].texture = t;

                    ft[index]:SetWidth(35);
                    ft[index]:SetHeight(35);
                    ft[index].name = self.name;
                    ft[index].link = item.link;
                    ft[index]:SetScript("OnEnter", sockets.showGameTooltip);
                    ft[index]:SetScript("OnLeave", sockets.hideGameTooltip);
                    ft[index]:SetScript("OnClick", function (self, button, down)
                        gamname = item.name;
                        bag = UseContainerItemByName(gamname, 0);
                        slot = UseContainerItemByName(gamname, 1);
                        if bag ~= false and slot ~= false then
                            SocketInventoryItem(slotID);
                            C_Container.PickupContainerItem(bag, slot);
                            ClickSocketButton(selectedSocketSlot);
                            AcceptSockets();
                            CloseSocketInfo();
                            clicked = true
                            pcall(hideFrame);
                        end    
                    end);
                    ft[index]:Show();
                    index = index + 1;
                end
            end
        end
    end
    if not IsShiftKeyDown() then
        clicked = false;
        pcall(hideFrame);
    end
end

function hideFrame()
    for id, item in pairs(ft) do
        item:Hide();
        ft[id] = nil;
    end
end

function Split(s, delimiter)
    result = {};
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match);
    end
    return result;
end

function loadGems()
    gemID = {};
    for bag = 0,4 do
        for slot = 1,C_Container.GetContainerNumSlots(bag) do
            local itemL = C_Container.GetContainerItemLink(bag,slot);
            if itemL then
                local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemIcon, itemSellPrice, itemClassID, itemSubClassID, bindType, expacID, itemSetID, isCraftingReagent = GetItemInfo(itemL);
                if itemClassID == 3 then
                    local arrayItem = { ["link"] = itemL, ["name"] = itemName, ["icon"] = itemIcon };
                    gemID[itemName] = arrayItem;
                end
            end
        end
    end
end

function cleanUp(id)
    table.remove(ft, id)
end

function UseContainerItemByName(search, xy)
    for bag = 0,4 do
      for slot = 1,C_Container.GetContainerNumSlots(bag) do
        local item = C_Container.GetContainerItemLink(bag,slot);
        if item and item:find(search) then
            if xy == 0 then
                return bag;
            end
            if xy == 1 then
                return slot;
            end
        end
      end
    end
    return false;
  end

function CreateUIDropDownMenuTemplate(parent, count)
    local dropDown = CreateFrame("Frame", "WPDemoDropDown", parent, "UIDropDownMenuTemplate")
    dropDown:Hide()
    UIDropDownMenu_SetWidth(dropDown, 35)
    UIDropDownMenu_SetText(dropDown, "1")
    UIDropDownMenu_Initialize(dropDown, function(self, level, menuList)
        local info = UIDropDownMenu_CreateInfo()
            for i=1, count do
                info.text = i
                info.menuList = i
                info.arg1 = i
                info.func = self.SetValue
                UIDropDownMenu_AddButton(info)
            end
        end)
    
    function dropDown:SetValue(newValue)
        UIDropDownMenu_SetText(dropDown, newValue)
        selectedSocketSlot = newValue
        CloseDropDownMenus()
    end

    return dropDown
end

function sockets:init()
    sockets.setTooltip();
    if good == false then
        C_Timer.After(5, function()
            sockets.setTooltip();
        end)
    end
    if good == false then
        C_Timer.After(30, function()
            sockets.setTooltip();
        end)
    end
    if good == false then
        C_Timer.After(60, function()
            sockets.setTooltip();
        end)
    end
end